petsc-3.10.5 2019-03-28
Report Typos and Errors

# MatMatMult

Performs Matrix-Matrix Multiplication C=A*B.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatMatMult(Mat A,Mat B,MatReuse scall,PetscReal fill,Mat *C)

Neighbor-wise Collective on Mat

### Input Parameters

| A | - the left matrix
| B | - the right matrix
| scall | - either MAT_INITIAL_MATRIX or MAT_REUSE_MATRIX
| fill | - expected fill as ratio of nnz(C)/(nnz(A) + nnz(B)), use PETSC_DEFAULT if you do not have a good estimate if the result is a dense matrix this is irrelevent

### Output Parameters

C -the product matrix

### Notes

Unless scall is MAT_REUSE_MATRIX C will be created.

MAT_REUSE_MATRIX can only be used if the matrices A and B have the same nonzero pattern as in the previous call and C was obtained from a previous call to this function with either MAT_INITIAL_MATRIX or MatMatMultSymbolic()

To determine the correct fill value, run with -info and search for the string "Fill ratio" to see the value actually needed.

If you have many matrices with the same non-zero structure to multiply, you should either

      1) use MAT_REUSE_MATRIX in all calls but the first or

      2) call MatMatMultSymbolic() once and then MatMatMultNumeric() for each product needed

In the special case where matrix B (and hence C) are dense you can create the correctly sized matrix C yourself and then call this routine with MAT_REUSE_MATRIX, rather than first having MatMatMult() create it for you. You can NEVER do this if the matrix C is sparse.

### See Also

MatMatMultSymbolic(), MatMatMultNumeric(), MatTransposeMatMult(), MatMatTransposeMult(), MatPtAP()

### Level

intermediate

### Location

src/mat/interface/matrix.c

### Examples

src/snes/examples/tutorials/ex70.c.html

### Implementations

MatMatMult_MPIDense_MPIAIJ in src/mat/impls/aij/mpi/mpiaij.c
MatMatMult_MPIAIJ_MPIAIJ in src/mat/impls/aij/mpi/mpimatmatmult.c
MatMatMult_MPIAIJ_MPIDense in src/mat/impls/aij/mpi/mpimatmatmult.c
MatMatMult_SeqDense_SeqAIJ in src/mat/impls/aij/seq/aij.c
MatMatMult_SeqAIJMKL_SeqAIJMKL_SpMV2 in src/mat/impls/aij/seq/aijmkl/aijmkl.c
MatMatMult_SeqAIJ_SeqAIJ in src/mat/impls/aij/seq/matmatmult.c
MatMatMult_SeqAIJ_SeqDense in src/mat/impls/aij/seq/matmatmult.c
MatMatMult_SeqAIJ_SeqAIJ_Combined in src/mat/impls/aij/seq/matmatmult.c
MatMatMult_MPIDense_MPIDense in src/mat/impls/dense/mpi/mpidense.c
MatMatMult_SeqDense_SeqDense in src/mat/impls/dense/seq/dense.c
MatMatMult_Elemental in src/mat/impls/elemental/matelem.cxx
MatMatMult_HYPRE_HYPRE in src/mat/impls/hypre/mhypre.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages